package com.qadeer.customer.service;


import com.qadeer.customer.dto.ProductDto;
import com.qadeer.customer.feign.FeignService;
import com.qadeer.customer.repository.CustomerRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class CustomerService {

    @Autowired
    private CustomerRepository repository;

    @Autowired
    private FeignService feignService;

    public List<ProductDto> buyProducts(String productName, String productQuantity) {
        ResponseEntity<List<ProductDto>> productDto = feignService.buyProducts(productName, productQuantity);
        return productDto.getBody();
    }

    public ProductDto getProductById(int id) {
        ProductDto productDto = feignService.getProductById(id);
        return productDto;
    }
}
