package com.qadeer.inventory.controller;

import com.qadeer.inventory.model.Product;
import com.qadeer.inventory.service.ProductService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/inventory")
public class InventoryController {

    @Autowired
    private ProductService service;

    @GetMapping("/hello")
    public String hello() {
        return "Hello";
    }

    @PostMapping("/restock")
    public ResponseEntity<?> restock(MultipartFile file) throws IOException {
        List< Product> productList = service.restock(file);
        return new ResponseEntity<List<Product>>(productList, HttpStatus.OK);
    }

    @GetMapping("/product/{id}")
    public ResponseEntity<?> getProductById(@PathVariable int id) {
        Product product = service.getProductById(id);
        return new ResponseEntity<Product>(product, HttpStatus.OK);
    }

    @GetMapping("/product/{productName}/{productQuantity}")
    public ResponseEntity<?> buyProducts(@PathVariable("productName") String productName, @PathVariable("productQuantity") int productQuantity) {
        List<Product> productList = service.buyProducts(productName, productQuantity);
        return new ResponseEntity<List<Product>>(productList, HttpStatus.OK);
    }

}
