package com.qadeer.inventory.service;

import com.qadeer.inventory.model.Product;
import com.qadeer.inventory.repository.ProductRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class ProductService {

    @Autowired
    private ProductRepository repository;

    public List<Product> getAllProducts() {
        return repository.findAll();
    }

    public Product getProductById(int id) {
        return repository.findById(id).get();
    }

    public void createProduct(Product product) {
        repository.save(product);
    }

    public List<Product> restock(MultipartFile file) throws IOException {
        InputStreamReader ir = new InputStreamReader(file.getInputStream());
        BufferedReader br = new BufferedReader(ir);
        String line = br.readLine();
        line = br.readLine();
        List<Product> productList = new ArrayList<>();
        while (line != null) {
            String[] content = line.split(",");
            String name = content[0].trim();
            int price = Integer.parseInt(content[1]);
            int quantity = Integer.parseInt(content[2]);
            Product product = new Product(name, price, quantity);
            repository.save(product);
            productList.add(product);
            line = br.readLine();
        }
        return productList;
    }

    public List<Product> buyProducts(String productName, int requiredQuant) {
        List<Product> productList = repository.findByName(productName);
        List<Product> myProducts = new ArrayList<>();
        int requiredProducts = 0;
        for(Product product: productList) {
            if (product.getQuantity() >= requiredQuant) {
                // create copy of product object.
                Product deliverProduct = new Product();
                deliverProduct.setId(product.getId());
                deliverProduct.setName(product.getName());
                deliverProduct.setPrice(product.getPrice());
                deliverProduct.setQuantity(requiredQuant);
                myProducts.add(deliverProduct);
                product.setQuantity(product.getQuantity() - requiredQuant);
                repository.save(product);
            }
            else if (product.getQuantity() > 0 && product.getQuantity() < requiredQuant){
                requiredProducts = requiredQuant - product.getQuantity();
                // create copy of product object.
                Product deliverProduct = new Product();
                deliverProduct.setId(product.getId());
                deliverProduct.setName(product.getName());
                deliverProduct.setPrice(product.getPrice());
                deliverProduct.setQuantity(product.getQuantity());
                System.out.println(requiredProducts);
                myProducts.add(deliverProduct);
                product.setQuantity(0);
                repository.save(product);
            }
            else {
                myProducts.add(null);
            }
        }
        return myProducts;
    }
    Map<String, ProductDto> productMap = new HashMap<>();
    List<ProductDto> productDtoList = (List<ProductDto>) productMap.values();
    repository.saveAll(productDtoList);
}
