package com.qadeer.seller.controller;

import com.qadeer.seller.dto.ProductDto;
import com.qadeer.seller.model.Seller;
import com.qadeer.seller.service.SellerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/seller")
public class SellerController {

    @Autowired
    private SellerService service;

    @GetMapping("/hello")
    public String hello() {
        return "Hello";
    }

    @PostMapping
    public void createProduct(@RequestBody Seller seller) {
        service.saveProduct(seller);
    }

    @GetMapping("/{id}")
    public Seller getProduct(@PathVariable int id) {
        return service.getProduct(id);
    }

    @GetMapping("/product/{id}")
    public ResponseEntity<?> getProductById(@PathVariable int id) {
        ProductDto productDto = service.getProductById(id);
        return ResponseEntity.ok(productDto);

    }

}
