package com.qadeer.seller.service;

import com.qadeer.seller.dto.ProductDto;
import com.qadeer.seller.feign.FeignService;
import com.qadeer.seller.model.Seller;
import com.qadeer.seller.repository.SellerRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static java.awt.SystemColor.text;

@Service
public class SellerService {

    @Autowired
    private SellerRepository repository;

    @Autowired
    private FeignService feignService;

    String path = "/Users/aqadeer/Desktop/java-training-project-final/seller-service/orders.csv";

    FileWriter fw = new FileWriter(path);

    public SellerService() throws IOException {
    }

    public void saveProduct(Seller seller){
        repository.save(seller);
    };

    public Seller getProduct(int id) {
        return repository.findById(id).get();
    }

    public ProductDto getProductById(int id) {
        ProductDto productDto = feignService.getProductById(id);
        orderLogs(productDto);
        return productDto;
    }

    public void orderLogs(ProductDto productDto) {
//        String path = "/Users/aqadeer/Desktop/java-training-project-final/seller-service/orders.csv";
//        BufferedWriter bw = null;

        try {
            DateTimeFormatter dtf = DateTimeFormatter.ofPattern("dd/MMM/yyyy HH:mm:ss");
            LocalDateTime now = LocalDateTime.now();
            String myTime = dtf.format(now);
            String text = productDto.toString() + " " + myTime + "\n";
            Files.write(Paths.get(path), text.getBytes(), StandardOpenOption.APPEND);
//            bw = new BufferedWriter(fw);
//            bw.append(productDto.toString());
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        finally {
            //                bw.close();
        }

    }
}
